#include <iostream>
#include <fstream>

#include <torch/MatDataSet.h>
#include <torch/MeanVarNorm.h>
#include <torch/DiskXFile.h>

using namespace std;
using namespace Torch;

int main(int argc, char** argv) {
	int n_inputs = 2;
	int n_hidden = 3;
	int n_targets = 4;

	char traindatafile[] = "data/KA2_train";

	DiskXFile out("cout", "w");


	MatDataSet data(traindatafile, n_inputs, n_targets);
//	MeanVarNorm* mvn = new(allocator) MeanVarNorm(data);

//	data.preProcess(mvn);
	
	out.printf("FIRST\n");
	for(int example=0; example < data.n_examples; ++example) {
		data.setExample(example);
		data.pushExample();
		out.printf("SetExample %d\n", example);

		for(int nfi=0; nfi < data.inputs->n_frames; ++nfi) {
			out.flush();
			out.printf("inputs  @0x%X, ex %d, frame %d: ", 
				&(data.inputs->frames[nfi]),
				example, nfi);
			for(int ni=0; ni < data.inputs->frame_size; ++ni)
				out.printf("%f (%d), ",
					(data.inputs->frames)[nfi][ni], ni);
			out.flush();
		}
		out.printf("\n");

		for(int nfi=0; nfi < data.targets->n_frames; ++nfi) { 
			out.flush();
			out.printf("targets @0x%X, ex %d, frame %d: ", 
				&(data.targets->frames[nfi]),
				example, nfi);
			for(int ni=0; ni < data.targets->frame_size; ++ni)
				out.printf("%f (%d), ",
					(data.targets->frames)[nfi][ni], ni);
			out.flush();
		}
		out.printf("\n");

		out.flush();
	}

	out.printf("END\n");
	return 0;
}
